
#ifdef _WIN32

#include <windows.h>
#include <tchar.h>
#include <stdarg.h>

#ifdef DYNAMIC_LINK
#define EXPORT __declspec(dllexport)

int EXPORT DllEntryPoint(HINSTANCE hinst,unsigned long reason,void* lpReserved)
{
		return 1;
}
#else
#define EXPORT
#endif // DYNAMIC_LINK

#else // _WIN32

#define EXPORT

#endif // _WIN32



static const unsigned char *cin = NULL;
static int nin = -1;
static int ninmax = -1;
static int std_getc_mode = 1;

static int std_getc(FILE *f)
{
	if(std_gc_ndx){
		return std_gc_buf[--std_gc_ndx];
	} else {
		if( std_getc_mode == 1 ) {
			return getc(f);
		}
		if( std_getc_mode == 2 && cin != NULL ) {
			if( ninmax >= 0 ) {
				if( nin >= ninmax ) {
					return EOF;
				}
				else {
					nin++;
					return *cin++;
				}
			}
			else {
				if( *cin ) {
					return *cin++;
				}
				else {
					return EOF;
				}
			}
		}
	}
	return EOF;
}

static FILE *fout = NULL;
static unsigned char *cout = NULL;
static int nout = -1;
static int noutmax = -1;
static int std_putc_mode = 1;

static void std_putc(int c)
{
	if(c!=EOF) {
		if( (std_putc_mode & 1) && fout != NULL ) {
			putc(c,fout);
		}
		if( (std_putc_mode & 4) && nout != -1 ) {
			if ( noutmax >= 0 && nout >= noutmax ) std_putc_mode &= ~2;
			nout++;
		}
		if( (std_putc_mode & 2) && cout != NULL ) {
			*cout++ = c;
		}
	}
}


static void reinitdll()
{
	cin = NULL;
	nin = -1;
	ninmax = -1;
	std_getc_mode = 1;
	fout = stdout;
	cout = NULL;
	nout = -1;
	noutmax = -1;
	std_putc_mode = 1;
}


EXPORT void nkf_set_option(const char *opt)
{
	char *p = malloc(strlen(opt)+2);
	if(!p)
		return;

	if(*opt=='-') {
		strcpy(p, opt);
	}
	else {
		*p = '-';
		strcpy(p+1, opt);
	}
	reinit();
	options(p);
	free(p);
}

EXPORT void nkf_convert(char *dst, const char *src)
{
	std_putc_mode = 2;
	cout = dst;
	noutmax = -1;
	nout = -1;
	std_getc_mode = 2;
	cin = src;
	ninmax = -1;
	nin = -1;
	kanji_convert(NULL);
	*cout = 0;
}

EXPORT size_t nkf_convert_safe(char *dst, size_t dst_length, const char *src, size_t src_length)
{
	if(src==NULL)
		return 0;
	std_putc_mode = 6;
	cout = dst;
	noutmax = dst_length;
	nout = 0;
	std_getc_mode = 2;
	cin = src;
	ninmax = src_length;
	nin = 0;
	kanji_convert(NULL);
	if(nout < noutmax)
		*cout = 0;
	return nout;
}

EXPORT int nkf_get_kanji_code()
{
	int iCode=0;
	if(iconv==w_iconv)
		iCode=3;
	else if(iconv==w_iconv16) {
		if(utf16_mode==UTF16BE_INPUT)
			iCode=5;
		else
			iCode=4;
	}
	else if(iconv==e_iconv) {
		if(estab_f==FALSE)
			iCode=2;
		else
			iCode=1;
	}
	return iCode;
}

EXPORT const char* nkf_version()
{
	static char version[1024] = "\0";
	if(!version[0]) {
		sprintf(version, "Network Kanji Filter Version " NKF_VERSION " (" NKF_RELEASE_DATE" )\n%s", CopyRight);
	}
	return version;
}


