#include <vector>
#include "../nkf.h"


size_t get_filesize(FILE *f) {
	size_t prev = ftell(f);
	fseek(f, 0, SEEK_END);
	size_t size = ftell(f);
	fseek(f, prev, SEEK_SET);
	return size;
}

void convert_and_print(const char *filename, const char *opt) {
	nkf_set_option(opt);
	if(FILE *f = fopen(filename, "rb")) {
		std::vector<char> src, dst;
		src.resize(get_filesize(f)+1);
		fread(&src[0], 1, src.size()-1, f);
		fclose(f);

		dst.resize(src.size()*2);
		nkf_convert(&dst[0], &src[0]);
		printf("src: %d byte\ndst: %d byte\n%s\n", strlen(&src[0]), strlen(&dst[0]), &dst[0]);
	}
}

int main(int argc, char **argv) {
	const char *option = "-s";
	if(argc>1)
		option = argv[1];
	printf("%s\n\n", nkf_version());
	printf("option: %s\n", option);
	convert_and_print("sjis.txt", option);
	convert_and_print("euc.txt", option);
	convert_and_print("utf8.txt", option);
}
